package org.jeecg.modules.ctop.service.impl;

import cn.com.ctop.common.module.entity.MaterialImageInfo;
import cn.com.ctop.common.module.entity.SysUser;
import cn.com.ctop.common.module.service.IMaterialImageInfoService;
import cn.com.ctop.common.module.utils.ResultMapUtils;
import cn.com.ctop.common.module.utils.StatusCode;
import cn.com.ctop.toutiao.modules.report.DTO.ImageCostVO;
import cn.com.ctop.toutiao.modules.report.mapper.BytedanceReportMaterialDailyMapper;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.jeecg.modules.ctop.service.IImageReportDailyService;
import org.jeecg.modules.system.service.ISysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class ImageReportDailyServiceImpl implements IImageReportDailyService {

    @Override
    public Map<String,Object> bytedanceImageCost(JSONObject data) {
        Map<String,Object>result = new HashMap<>();
        String startDate = data.getString("startDate");
        if(null == startDate||startDate.trim().equals("")){
            startDate = null;
        }
        String endDate = data.getString("endDate");
        if(null == endDate||endDate.trim().equals("")){
            endDate = null;
        }
        JSONArray accountList = data.getJSONArray("accountList");
        if(null==accountList||accountList.isEmpty()){
            accountList = null;
        }
        String code = data.getString("code");
        if(null == code||code.trim().equals("")){
            code = null;
        }
        Integer pageSize = data.getInteger("pageSize");
        Integer pageNumber = data.getInteger("pageNumber");
        if(null == pageNumber||pageNumber ==0){
            pageNumber = 1;
        }
        if(null == pageSize||pageSize ==0){
            pageSize = 10;
        }
        PageHelper.startPage(pageNumber,pageSize);
        List<ImageCostVO> vos = bytedanceReportMaterialDailyMapper.bytedanceImageCost(startDate,endDate,accountList,code,(pageNumber-1)*pageSize,pageSize);
        PageInfo<ImageCostVO> pageInfo = new PageInfo<>(vos);
        if(null!=vos&&!vos.isEmpty()){
            List<ImageCostVO>setVos = new ArrayList<>();
            for(ImageCostVO vo:vos){
                MaterialImageInfo imageInfo = imageInfoService.getByCode(vo.getSignature());
                if(null!=imageInfo){
                    vo.setUserId(imageInfo.getUserId());
                    SysUser user = sysUserService.getById(imageInfo.getUserId());
                    vo.setUserName(user.getUsername());
                }else{
                    vo.setUserName("-");
                }
                setVos.add(vo);
            }
            pageInfo.setList(setVos);
        }
        result.put("data",pageInfo);
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Override
    public Map<String, Object> kuaishouImageCost(JSONObject data) {
        Map<String,Object>result = new HashMap<>();
        String startDate = data.getString("startDate");
        if(null == startDate||startDate.trim().equals("")){
            startDate = null;
        }
        String endDate = data.getString("endDate");
        if(null == endDate||endDate.trim().equals("")){
            endDate = null;
        }
        JSONArray accountList = data.getJSONArray("accountList");
        if(null==accountList||accountList.isEmpty()){
            accountList = null;
        }
        String code = data.getString("code");
        if(null == code||code.trim().equals("")){
            code = null;
        }
        Integer pageSize = data.getInteger("pageSize");
        Integer pageNumber = data.getInteger("pageNumber");
        if(null == pageNumber||pageNumber ==0){
            pageNumber = 1;
        }
        if(null == pageSize||pageSize ==0){
            pageSize = 10;
        }
        PageHelper.startPage(pageNumber,pageSize);
        List<ImageCostVO> vos = bytedanceReportMaterialDailyMapper.bytedanceImageCost(startDate,endDate,accountList,code,(pageNumber-1)*pageSize,pageSize);
        PageInfo<ImageCostVO> pageInfo = new PageInfo<>(vos);
        if(null!=vos&&!vos.isEmpty()){
            List<ImageCostVO>setVos = new ArrayList<>();
            for(ImageCostVO vo:vos){
                MaterialImageInfo imageInfo = imageInfoService.getByCode(vo.getSignature());
                if(null!=imageInfo){
                    vo.setUserId(imageInfo.getUserId());
                    SysUser user = sysUserService.getById(imageInfo.getUserId());
                    vo.setUserName(user.getUsername());
                }else{
                    vo.setUserName("-");
                }
                setVos.add(vo);
            }
            pageInfo.setList(setVos);
        }
        result.put("data",pageInfo);
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;
    }

    @Autowired
    private IMaterialImageInfoService imageInfoService;
    @Autowired
    private BytedanceReportMaterialDailyMapper bytedanceReportMaterialDailyMapper;
    @Autowired
    private ISysUserService sysUserService;
}
