package cn.com.ctop.kuaishou.modules.batch.service.impl;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.kuaishou.modules.batch.entity.CollectionSlogans;
import cn.com.ctop.kuaishou.modules.batch.mapper.CollectionSlogansMapper;
import cn.com.ctop.kuaishou.modules.batch.service.ICollectionSlogansService;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xxl.job.core.enums.NoEn;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 收藏的广告语
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-10-12
 */
@Service
public class CollectionSlogansServiceImpl extends ServiceImpl<CollectionSlogansMapper, CollectionSlogans> implements ICollectionSlogansService {

    @Autowired
    CollectionSlogansMapper collectionSlogansMapper;

    @Override
    public void saveCollectionSlogans(JSONObject requestJson) {
        CollectionSlogans co = new CollectionSlogans();
        String userId = requestJson.getString("userId");
        Long accountId = requestJson.getLong("accountId");
        if (!Check.isNull(requestJson.getJSONArray("coverSlogansList"))) {
            //封面广告语
            co.setType(NoEn.NO1.valueStr());
            co.setValue(requestJson.getJSONArray("coverSlogansList").toString());
        }
        if (!Check.isNull(requestJson.getJSONArray("captionsList"))) {
            co.setType(NoEn.NO2.valueStr());
            co.setValue(requestJson.getJSONArray("captionsList").toString());
        }
        co.setAccountId(accountId);
        co.setUserId(userId);
        JSONObject slogansJson = getByUserId(userId, accountId.toString(), co.getType());
        if (!Check.isNull(slogansJson)) {
            QueryWrapper<CollectionSlogans> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", slogansJson.getInteger("id"));
            collectionSlogansMapper.update(co, queryWrapper);
        } else {
            collectionSlogansMapper.insert(co);
        }
    }

    @Override
    public JSONObject getByUserId(String userId, String accountId, String type) {
        QueryWrapper<CollectionSlogans> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("account_id", accountId);
        queryWrapper.eq("user_id", userId);
        queryWrapper.eq("type", type);
        queryWrapper.last("limit 1");
        CollectionSlogans slogans = collectionSlogansMapper.selectOne(queryWrapper);
        JSONObject resultJson = null;
        if (!Check.isNull(slogans)) {
            resultJson = (JSONObject) JSONObject.toJSON(slogans);
            resultJson.put("value", JSONArray.parseArray(slogans.getValue()));
        }
        return resultJson;
    }
}
